diff --git a/lustre/llite/file.c b/lustre/llite/file.c
index c186b5a..4262b0d 100644
--- a/lustre/llite/file.c
+++ b/lustre/llite/file.c
@@ -892,7 +892,7 @@ static ssize_t ll_file_io_generic(const struct lu_env *env,
 out:
         cl_io_fini(env, io);
         if (iot == CIT_WRITE)
-                lli->lli_write_rc = result < 0 ? : 0;
+                lli->lli_write_rc = result < 0 ? result : 0;
         return result;
 }
 
@@ -1864,10 +1864,13 @@ loff_t ll_file_seek(struct file *file, loff_t offset, int origin)
         ll_stats_ops_tally(ll_i2sbi(inode), LPROC_LL_LLSEEK, 1);
 
         if (origin == 2) { /* SEEK_END */
-                int nonblock = 0, rc;
+                int rc;
+#if 0
+                int nonblock = 0;
 
                 if (file->f_flags & O_NONBLOCK)
                         nonblock = LDLM_FL_BLOCK_NOWAIT;
+#endif
 
                 rc = cl_glimpse_size(inode);
                 if (rc != 0)
@@ -1917,9 +1920,13 @@ int ll_flush(struct file *file)
         return rc ? -EIO : 0;
 }
 
-int ll_fsync(struct file *file, struct dentry *dentry, int data)
+int ll_fsync(struct file *file,
+#ifndef HAVE_FSYNC_TWO_ARGS
+             struct dentry *dentry,
+#endif
+             int data)
 {
-        struct inode *inode = dentry->d_inode;
+        struct inode *inode = file->f_dentry->d_inode;
         struct ll_inode_info *lli = ll_i2info(inode);
         struct lov_stripe_md *lsm = lli->lli_smd;
         struct ptlrpc_request *req;
@@ -1982,7 +1989,7 @@ int ll_fsync(struct file *file, struct dentry *dentry, int data)
                         rc = err;
                 OBDO_FREE(oinfo->oi_oa);
                 OBD_FREE_PTR(oinfo);
-                lli->lli_write_rc = err < 0 ? : 0;
+                lli->lli_write_rc = err < 0 ? err : 0;
         }
 
         RETURN(rc);
@@ -2175,7 +2182,6 @@ int __ll_inode_revalidate_it(struct dentry *dentry, struct lookup_intent *it,
 {
         struct inode *inode = dentry->d_inode;
         struct ptlrpc_request *req = NULL;
-        struct ll_sb_info *sbi;
         struct obd_export *exp;
         int rc = 0;
         ENTRY;
@@ -2184,7 +2190,6 @@ int __ll_inode_revalidate_it(struct dentry *dentry, struct lookup_intent *it,
                 CERROR("REPORT THIS LINE TO PETER\n");
                 RETURN(0);
         }
-        sbi = ll_i2sbi(inode);
 
         CDEBUG(D_VFSTRACE, "VFS Op:inode=%lu/%u(%p),name=%s\n",
                inode->i_ino, inode->i_generation, inode, dentry->d_name.name);
@@ -2232,11 +2237,9 @@ int __ll_inode_revalidate_it(struct dentry *dentry, struct lookup_intent *it,
                    here to preserve get_cwd functionality on 2.6.
                    Bug 10503 */
                 if (!dentry->d_inode->i_nlink) {
-                        cfs_spin_lock(&ll_lookup_lock);
-                        spin_lock(&dcache_lock);
+                        LL_LOCK_DCACHE;
                         ll_drop_dentry(dentry);
-                        spin_unlock(&dcache_lock);
-                        cfs_spin_unlock(&ll_lookup_lock);
+                        LL_UNLOCK_DCACHE;
                 }
 
                 ll_lookup_finish_locks(&oit, dentry);
@@ -2386,7 +2389,11 @@ int ll_fiemap(struct inode *inode, struct fiemap_extent_info *fieinfo,
 
 
 static
-int lustre_check_acl(struct inode *inode, int mask)
+int lustre_check_acl(struct inode *inode, int mask
+#ifdef HAVE_CHECK_ACL_THREE_ARGS
+                     , unsigned int flags
+#endif
+)
 {
 #ifdef CONFIG_FS_POSIX_ACL
         struct ll_inode_info *lli = ll_i2info(inode);
@@ -2411,10 +2418,12 @@ int lustre_check_acl(struct inode *inode, int mask)
 }
 
 #if (LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,10))
-#ifndef HAVE_INODE_PERMISION_2ARGS
-int ll_inode_permission(struct inode *inode, int mask, struct nameidata *nd)
-#else
+#ifdef HAVE_PERMISSION_FLAGS_ARG
+int ll_inode_permission(struct inode *inode, int mask, unsigned int flags)
+#elif defined(HAVE_INODE_PERMISION_2ARGS)
 int ll_inode_permission(struct inode *inode, int mask)
+#else
+int ll_inode_permission(struct inode *inode, int mask, struct nameidata *nd)
 #endif
 {
         int rc = 0;
@@ -2439,7 +2448,7 @@ int ll_inode_permission(struct inode *inode, int mask)
                 return lustre_check_remote_perm(inode, mask);
 
         ll_stats_ops_tally(ll_i2sbi(inode), LPROC_LL_INODE_PERM, 1);
-        rc = generic_permission(inode, mask, lustre_check_acl);
+        rc = generic_permission(inode, mask, flags, lustre_check_acl);
 
         RETURN(rc);
 }
diff --git a/lustre/llite/llite_internal.h b/lustre/llite/llite_internal.h
index a9fdab1..0aabc48 100644
--- a/lustre/llite/llite_internal.h
+++ b/lustre/llite/llite_internal.h
@@ -660,8 +660,6 @@ void ll_done_writing_attr(struct inode *inode, struct md_op_data *op_data);
 int ll_som_update(struct inode *inode, struct md_op_data *op_data);
 int ll_inode_getattr(struct inode *inode, struct obdo *obdo,
                      __u64 ioepoch, int sync);
-int ll_md_setattr(struct inode *inode, struct md_op_data *op_data,
-                  struct md_open_data **mod);
 void ll_pack_inode2opdata(struct inode *inode, struct md_op_data *op_data,
                           struct lustre_handle *fh);
 extern void ll_rw_stats_tally(struct ll_sb_info *sbi, pid_t pid,
@@ -671,10 +669,12 @@ int ll_getattr_it(struct vfsmount *mnt, struct dentry *de,
                struct lookup_intent *it, struct kstat *stat);
 int ll_getattr(struct vfsmount *mnt, struct dentry *de, struct kstat *stat);
 struct ll_file_data *ll_file_data_get(void);
-#ifndef HAVE_INODE_PERMISION_2ARGS
-int ll_inode_permission(struct inode *inode, int mask, struct nameidata *nd);
-#else
+#ifdef HAVE_PERMISSION_FLAGS_ARG
+int ll_inode_permission(struct inode *inode, int mask, unsigned int);
+#elif defined(HAVE_INODE_PERMISSION_2ARGS)
 int ll_inode_permission(struct inode *inode, int mask);
+#else
+int ll_inode_permission(struct inode *inode, int mask, struct nameidata *nd);
 #endif
 int ll_lov_setstripe_ea_info(struct inode *inode, struct file *file,
                              int flags, struct lov_user_md *lum,
@@ -686,7 +686,11 @@ int ll_dir_setstripe(struct inode *inode, struct lov_user_md *lump,
                      int set_default);
 int ll_dir_getstripe(struct inode *inode, struct lov_mds_md **lmm,
                      int *lmm_size, struct ptlrpc_request **request);
-int ll_fsync(struct file *file, struct dentry *dentry, int data);
+int ll_fsync(struct file *file,
+#ifndef HAVE_FSYNC_TWO_ARGS
+             struct dentry *dentry,
+#endif
+             int data);
 int ll_do_fiemap(struct inode *inode, struct ll_user_fiemap *fiemap,
               int num_bytes);
 int ll_merge_lvb(struct inode *inode);
@@ -709,7 +713,13 @@ int ll_drop_dentry(struct dentry *dentry);
 void ll_unhash_aliases(struct inode *);
 void ll_frob_intent(struct lookup_intent **itp, struct lookup_intent *deft);
 void ll_lookup_finish_locks(struct lookup_intent *it, struct dentry *dentry);
+#if 1
+int ll_dcompare(const struct dentry *parent, const struct inode *pinode,
+                const struct dentry *dentry, const struct inode *inode,
+                unsigned int len, const char *str, const struct qstr *d_name);
+#else
 int ll_dcompare(struct dentry *parent, struct qstr *d_name, struct qstr *name);
+#endif
 int ll_revalidate_it_finish(struct ptlrpc_request *request,
                             struct lookup_intent *it, struct dentry *de);
 
@@ -723,8 +733,8 @@ void ll_put_super(struct super_block *sb);
 void ll_kill_super(struct super_block *sb);
 struct inode *ll_inode_from_lock(struct ldlm_lock *lock);
 void ll_clear_inode(struct inode *inode);
-int ll_setattr_raw(struct inode *inode, struct iattr *attr);
 int ll_setattr(struct dentry *de, struct iattr *attr);
+#define HAVE_STATFS_DENTRY_PARAM 1
 #ifndef HAVE_STATFS_DENTRY_PARAM
 int ll_statfs(struct super_block *sb, struct kstatfs *sfs);
 #else
diff --git a/lustre/llite/llite_lib.c b/lustre/llite/llite_lib.c
index d9635a1..d36aea2 100644
--- a/lustre/llite/llite_lib.c
+++ b/lustre/llite/llite_lib.c
@@ -585,7 +585,7 @@ void lustre_dump_dentry(struct dentry *dentry, int recur)
                " flags=0x%x, fsdata=%p, %d subdirs\n", dentry,
                dentry->d_name.len, dentry->d_name.name,
                dentry->d_parent->d_name.len, dentry->d_parent->d_name.name,
-               dentry->d_parent, dentry->d_inode, atomic_read(&dentry->d_count),
+               dentry->d_parent, dentry->d_inode, d_refcount(dentry),
                dentry->d_flags, dentry->d_fsdata, subdirs);
         if (dentry->d_inode != NULL)
                 ll_dump_inode(dentry->d_inode);
@@ -1109,13 +1109,13 @@ void ll_clear_inode(struct inode *inode)
                 lli->lli_smd = NULL;
         }
 
-
         EXIT;
 }
 
-int ll_md_setattr(struct inode *inode, struct md_op_data *op_data,
-                  struct md_open_data **mod)
+static int ll_md_setattr(struct dentry *dentry, struct md_op_data *op_data,
+                         struct md_open_data **mod)
 {
+        struct inode *inode = dentry->d_inode;
         struct lustre_md md;
         struct ll_sb_info *sbi = ll_i2sbi(inode);
         struct ptlrpc_request *request = NULL;
@@ -1137,7 +1137,11 @@ int ll_md_setattr(struct inode *inode, struct md_op_data *op_data,
                          * Pretend we done everything. */
                         if (!S_ISREG(inode->i_mode) &&
                             !S_ISDIR(inode->i_mode))
+#ifdef HAVE_SIMPLE_SETATTR
+                                rc = simple_setattr(dentry, &op_data->op_attr);
+#else
                                 rc = inode_setattr(inode, &op_data->op_attr);
+#endif
                 } else if (rc != -EPERM && rc != -EACCES && rc != -ETXTBSY) {
                         CERROR("md_setattr fails: rc = %d\n", rc);
                 }
@@ -1156,7 +1160,11 @@ int ll_md_setattr(struct inode *inode, struct md_op_data *op_data,
          * above to avoid invoking vmtruncate, otherwise it is important
          * to call vmtruncate in inode_setattr to update inode->i_size
          * (bug 6196) */
+#ifdef HAVE_SIMPLE_SETATTR
+        rc = simple_setattr(dentry, &op_data->op_attr);
+#else
         rc = inode_setattr(inode, &op_data->op_attr);
+#endif
 
         /* Extract epoch data if obtained. */
         op_data->op_handle = md.body->handle;
@@ -1233,8 +1241,9 @@ static int ll_setattr_ost(struct inode *inode, struct iattr *attr)
  * I don't believe it is possible to get e.g. ATTR_MTIME_SET and ATTR_SIZE
  * at the same time.
  */
-int ll_setattr_raw(struct inode *inode, struct iattr *attr)
+static int ll_setattr_raw(struct dentry *dentry, struct iattr *attr)
 {
+        struct inode *inode = dentry->d_inode;
         struct ll_inode_info *lli = ll_i2info(inode);
         struct lov_stripe_md *lsm = lli->lli_smd;
         struct md_op_data *op_data = NULL;
@@ -1310,7 +1319,7 @@ int ll_setattr_raw(struct inode *inode, struct iattr *attr)
             (ia_valid & (ATTR_SIZE | ATTR_MTIME | ATTR_MTIME_SET)))
                 op_data->op_flags = MF_EPOCH_OPEN;
 
-        rc = ll_md_setattr(inode, op_data, &mod);
+        rc = ll_md_setattr(dentry, op_data, &mod);
         if (rc)
                 GOTO(out, rc);
 
@@ -1368,7 +1377,7 @@ int ll_setattr(struct dentry *de, struct iattr *attr)
             !(attr->ia_valid & ATTR_KILL_SGID))
                 attr->ia_valid |= ATTR_KILL_SGID;
 
-        return ll_setattr_raw(de->d_inode, attr);
+        return ll_setattr_raw(de, attr);
 }
 
 int ll_statfs_internal(struct super_block *sb, struct obd_statfs *osfs,
@@ -1748,7 +1757,12 @@ void ll_delete_inode(struct inode *inode)
         }
         /* Workaround end */
 
+#ifdef HAVE_EVICT_INODE
+        ll_clear_inode(inode);
+        end_writeback(inode);
+#else
         clear_inode(inode);
+#endif
 
         EXIT;
 }
diff --git a/lustre/llite/llite_mmap.c b/lustre/llite/llite_mmap.c
index 81ee3fb..3d03c8e 100644
--- a/lustre/llite/llite_mmap.c
+++ b/lustre/llite/llite_mmap.c
@@ -35,7 +35,12 @@
  */
 
 #ifndef AUTOCONF_INCLUDED
-#include <linux/config.h>
+#  include <linux/version.h>
+#  if LINUX_VERSION_CODE > KERNEL_VERSION(2, 6, 37)
+#    include <generated/autoconf.h>
+#  else
+#    include <linux/config.h>
+#  endif
 #endif
 #include <linux/kernel.h>
 #include <linux/mm.h>
diff --git a/lustre/llite/lloop.c b/lustre/llite/lloop.c
index 6975c85..52aa32a 100644
--- a/lustre/llite/lloop.c
+++ b/lustre/llite/lloop.c
@@ -80,7 +80,12 @@
  */
 
 #ifndef AUTOCONF_INCLUDED
-#include <linux/config.h>
+#  include <linux/version.h>
+#  if LINUX_VERSION_CODE > KERNEL_VERSION(2, 6, 37)
+#    include <generated/autoconf.h>
+#  else
+#    include <linux/config.h>
+#  endif
 #endif
 #include <linux/module.h>
 
@@ -737,7 +742,7 @@ static enum llioc_iter lloop_ioctl(struct inode *unused, struct file *file,
                 if (put_user((long)old_encode_dev(dev), (long*)arg))
                         GOTO(out, err = -EFAULT);
 
-                bdev = open_by_devnum(dev, file->f_mode);
+                bdev = blkdev_get_by_dev(dev, file->f_mode, NULL);
                 if (IS_ERR(bdev))
                         GOTO(out, err = PTR_ERR(bdev));
 
diff --git a/lustre/llite/namei.c b/lustre/llite/namei.c
index ad98239..6c6282b 100644
--- a/lustre/llite/namei.c
+++ b/lustre/llite/namei.c
@@ -154,8 +154,10 @@ static void ll_drop_negative_dentry(struct inode *dir)
 {
         struct dentry *dentry, *tmp_alias, *tmp_subdir;
 
-        cfs_spin_lock(&ll_lookup_lock);
-        spin_lock(&dcache_lock);
+        LL_LOCK_DCACHE;
+#ifndef HAVE_DCACHE_LOCK
+        cfs_spin_lock(&dir->i_lock);
+#endif
 restart:
         list_for_each_entry_safe(dentry, tmp_alias,
                                  &dir->i_dentry,d_alias) {
@@ -174,8 +176,10 @@ restart:
                         }
                 }
         }
-        spin_unlock(&dcache_lock);
-        cfs_spin_unlock(&ll_lookup_lock);
+#ifndef HAVE_DCACHE_LOCK
+        cfs_spin_unlock(&dir->i_lock);
+#endif
+        LL_UNLOCK_DCACHE;
 }
 
 
@@ -322,7 +326,7 @@ static void ll_d_add(struct dentry *de, struct inode *inode)
         CDEBUG(D_DENTRY, "adding inode %p to dentry %p\n", inode, de);
         /* d_instantiate */
         if (!list_empty(&de->d_alias)) {
-                spin_unlock(&dcache_lock);
+                LOCK_DCACHE;
                 CERROR("dentry %.*s %p alias next %p, prev %p\n",
                        de->d_name.len, de->d_name.name, de,
                        de->d_alias.next, de->d_alias.prev);
@@ -334,12 +338,12 @@ static void ll_d_add(struct dentry *de, struct inode *inode)
 
         /* d_rehash */
         if (!d_unhashed(de)) {
-                spin_unlock(&dcache_lock);
+                UNLOCK_DCACHE;
                 CERROR("dentry %.*s %p hash next %p\n",
                        de->d_name.len, de->d_name.name, de, de->d_hash.next);
                 LBUG();
         }
-        d_rehash_cond(de, 0);
+        ll_d_rehash_cond(de, 0);
 }
 
 /* Search "inode"'s alias list for a dentry that has the same name and parent
@@ -354,8 +358,7 @@ static struct dentry *ll_find_alias(struct inode *inode, struct dentry *de)
         struct dentry *dentry;
         struct dentry *last_discon = NULL;
 
-        cfs_spin_lock(&ll_lookup_lock);
-        spin_lock(&dcache_lock);
+        LL_LOCK_DCACHE;
         list_for_each(tmp, &inode->i_dentry) {
                 dentry = list_entry(tmp, struct dentry, d_alias);
 
@@ -384,31 +387,33 @@ static struct dentry *ll_find_alias(struct inode *inode, struct dentry *de)
                            de->d_name.len) != 0)
                         continue;
 
-                dget_locked(dentry);
+                dget_dlock(dentry);
+
                 lock_dentry(dentry);
                 __d_drop(dentry);
                 unlock_dentry(dentry);
+
                 ll_dops_init(dentry, 0, 1);
-                d_rehash_cond(dentry, 0); /* avoid taking dcache_lock inside */
-                spin_unlock(&dcache_lock);
-                cfs_spin_unlock(&ll_lookup_lock);
+                ll_d_rehash_cond(dentry, 0); /* avoid taking dcache_lock inside */
+                LL_UNLOCK_DCACHE;
                 iput(inode);
                 CDEBUG(D_DENTRY, "alias dentry %.*s (%p) parent %p inode %p "
                        "refc %d\n", de->d_name.len, de->d_name.name, de,
-                       de->d_parent, de->d_inode, atomic_read(&de->d_count));
+                       de->d_parent, de->d_inode, d_refcount(de));
                 return dentry;
         }
 
         if (last_discon) {
                 CDEBUG(D_DENTRY, "Reuse disconnected dentry %p inode %p "
                         "refc %d\n", last_discon, last_discon->d_inode,
-                        atomic_read(&last_discon->d_count));
-                dget_locked(last_discon);
+                        d_refcount(last_discon));
+                dget_dlock(last_discon);
+
                 lock_dentry(last_discon);
                 last_discon->d_flags |= DCACHE_LUSTRE_INVALID;
                 unlock_dentry(last_discon);
-                spin_unlock(&dcache_lock);
-                cfs_spin_unlock(&ll_lookup_lock);
+
+                LL_UNLOCK_DCACHE;
                 ll_dops_init(last_discon, 1, 1);
                 d_rehash(de);
                 d_move(last_discon, de);
@@ -420,8 +425,7 @@ static struct dentry *ll_find_alias(struct inode *inode, struct dentry *de)
         unlock_dentry(de);
         ll_d_add(de, inode);
 
-        spin_unlock(&dcache_lock);
-        cfs_spin_unlock(&ll_lookup_lock);
+        LL_UNLOCK_DCACHE;
 
         return de;
 }
@@ -481,9 +485,9 @@ int ll_lookup_it_finish(struct ptlrpc_request *request,
                    cannot afford to hash this dentry (done by ll_d_add) as it
                    might get picked up later when UPDATE lock will appear */
                 if (ll_have_md_lock(parent, MDS_INODELOCK_UPDATE, LCK_MINMODE)) {
-                        spin_lock(&dcache_lock);
+                        LOCK_DCACHE;
                         ll_d_add(*de, NULL);
-                        spin_unlock(&dcache_lock);
+                        UNLOCK_DCACHE;
                 } else {
                         /* negative lookup - and don't have update lock to
                          * parent */
@@ -793,10 +797,10 @@ static int ll_create_it(struct inode *dir, struct dentry *dentry, int mode,
         /* Negative dentry may be unhashed if parent does not have UPDATE lock,
          * but some callers, e.g. do_coredump, expect dentry to be hashed after
          * successful create. Hash it here. */
-        spin_lock(&dcache_lock);
+        LOCK_DCACHE;
         if (d_unhashed(dentry))
-                d_rehash_cond(dentry, 0);
-        spin_unlock(&dcache_lock);
+                ll_d_rehash_cond(dentry, 0);
+        UNLOCK_DCACHE;
         RETURN(0);
 }
 
diff --git a/lustre/llite/rw.c b/lustre/llite/rw.c
index 25f45fb..e07bbed 100644
--- a/lustre/llite/rw.c
+++ b/lustre/llite/rw.c
@@ -150,7 +150,6 @@ static struct ll_cl_context *ll_cl_init(struct file *file,
         cio = ccc_env_io(env);
         io = cio->cui_cl.cis_io;
         if (io == NULL && create) {
-                struct vvp_io *vio;
                 loff_t pos;
 
                 /*
@@ -160,7 +159,6 @@ static struct ll_cl_context *ll_cl_init(struct file *file,
                  */
 
                 io = ccc_env_thread_io(env);
-                vio = vvp_env_io(env);
                 ll_io_init(io, file, 1);
 
                 /* No lock at all for this kind of IO - we can't do it because
diff --git a/lustre/llite/rw26.c b/lustre/llite/rw26.c
index aba93e5..9eb378d 100644
--- a/lustre/llite/rw26.c
+++ b/lustre/llite/rw26.c
@@ -39,7 +39,12 @@
  */
 
 #ifndef AUTOCONF_INCLUDED
-#include <linux/config.h>
+#  include <linux/version.h>
+#  if LINUX_VERSION_CODE > KERNEL_VERSION(2, 6, 37)
+#    include <generated/autoconf.h>
+#  else
+#    include <linux/config.h>
+#  endif
 #endif
 #include <linux/kernel.h>
 #include <linux/mm.h>
diff --git a/lustre/llite/statahead.c b/lustre/llite/statahead.c
index 0385649..5cd1856 100644
--- a/lustre/llite/statahead.c
+++ b/lustre/llite/statahead.c
@@ -459,15 +459,13 @@ static int do_statahead_interpret(struct ll_statahead_info *sai)
                         GOTO(out, rc);
                 }
 
-                cfs_spin_lock(&ll_lookup_lock);
-                spin_lock(&dcache_lock);
+                LL_LOCK_DCACHE;
                 lock_dentry(dentry);
                 __d_drop(dentry);
                 dentry->d_flags &= ~DCACHE_LUSTRE_INVALID;
                 unlock_dentry(dentry);
-                d_rehash_cond(dentry, 0);
-                spin_unlock(&dcache_lock);
-                cfs_spin_unlock(&ll_lookup_lock);
+                ll_d_rehash_cond(dentry, 0);
+                LL_UNLOCK_DCACHE;
 
                 ll_lookup_finish_locks(it, dentry);
         }
diff --git a/lustre/llite/super25.c b/lustre/llite/super25.c
index 5f27094..f534340 100644
--- a/lustre/llite/super25.c
+++ b/lustre/llite/super25.c
@@ -92,8 +92,12 @@ struct super_operations lustre_super_operations =
 {
         .alloc_inode   = ll_alloc_inode,
         .destroy_inode = ll_destroy_inode,
+#ifdef HAVE_EVICT_INODE
+        .evict_inode   = ll_delete_inode,
+#else
         .clear_inode   = ll_clear_inode,
         .delete_inode  = ll_delete_inode,
+#endif
         .put_super     = ll_put_super,
         .statfs        = ll_statfs,
         .umount_begin  = ll_umount_begin,
diff --git a/lustre/lmv/lmv_obd.c b/lustre/lmv/lmv_obd.c
index cd4ab9d..03e36ac 100644
--- a/lustre/lmv/lmv_obd.c
+++ b/lustre/lmv/lmv_obd.c
@@ -2071,7 +2071,6 @@ static int lmv_rename(struct obd_export *exp, struct md_op_data *op_data,
         struct obd_device       *obd = exp->exp_obd;
         struct lmv_obd          *lmv = &obd->u.lmv;
         struct lmv_tgt_desc     *src_tgt;
-        struct lmv_tgt_desc     *tgt_tgt;
         int                      rc;
         int                      sidx;
         int                      loop = 0;
@@ -2131,7 +2130,6 @@ repeat:
         op_data->op_cap = cfs_curproc_cap_pack();
 
         src_tgt = lmv_get_target(lmv, mds1);
-        tgt_tgt = lmv_get_target(lmv, mds2);
 
         /*
          * LOOKUP lock on src child (fid3) should also be cancelled for
diff --git a/lustre/lov/lov_qos.c b/lustre/lov/lov_qos.c
index c1f8c96..42182cf 100644
--- a/lustre/lov/lov_qos.c
+++ b/lustre/lov/lov_qos.c
@@ -790,7 +790,6 @@ static int alloc_qos(struct obd_export *exp, int *idx_arr, int *stripe_cnt,
         int stripe_cnt_min = min_stripe_count(*stripe_cnt, flags);
         struct pool_desc *pool;
         struct ost_pool *osts;
-        struct lov_qos_rr *lqr;
         ENTRY;
 
         if (stripe_cnt_min < 1)
@@ -799,11 +798,9 @@ static int alloc_qos(struct obd_export *exp, int *idx_arr, int *stripe_cnt,
         pool = lov_find_pool(lov, poolname);
         if (pool == NULL) {
                 osts = &(lov->lov_packed);
-                lqr = &(lov->lov_qos.lq_rr);
         } else {
                 cfs_down_read(&pool_tgt_rw_sem(pool));
                 osts = &(pool->pool_obds);
-                lqr = &(pool->pool_rr);
         }
 
         obd_getref(exp->exp_obd);
diff --git a/lustre/lov/lovsub_lock.c b/lustre/lov/lovsub_lock.c
index 4810da4..263adff 100644
--- a/lustre/lov/lovsub_lock.c
+++ b/lustre/lov/lovsub_lock.c
@@ -205,7 +205,6 @@ int lov_sublock_modify(const struct lu_env *env, struct lov_lock *lov,
                        const struct cl_lock_descr *d, int idx)
 {
         struct cl_lock       *parent;
-        struct cl_lock       *child;
         struct lovsub_object *subobj;
         struct cl_lock_descr *pd;
         struct cl_lock_descr *parent_descr;
@@ -215,7 +214,6 @@ int lov_sublock_modify(const struct lu_env *env, struct lov_lock *lov,
         parent_descr = &parent->cll_descr;
         LASSERT(cl_lock_mode_match(d->cld_mode, parent_descr->cld_mode));
 
-        child  = sublock->lss_cl.cls_lock;
         subobj = cl2lovsub(sublock->lss_cl.cls_obj);
         pd     = &lov_env_info(env)->lti_ldescr;
 
diff --git a/lustre/lvfs/fsfilt_ext3.c b/lustre/lvfs/fsfilt_ext3.c
index 880041d..7cc0ccb 100644
--- a/lustre/lvfs/fsfilt_ext3.c
+++ b/lustre/lvfs/fsfilt_ext3.c
@@ -1521,6 +1521,33 @@ do {                                            \
         Q_COPY(out, in, dqb_valid);             \
 } while (0)
 
+static inline int
+ll_quota_on(struct super_block *sb, int off, int ver, char *name, int remount)
+{
+        if (sb->s_qcop->quota_on) {
+                return sb->s_qcop->quota_on(sb, off, ver, name
+#ifdef HAVE_QUOTA_ON_5ARGS
+                                            , remount
+#endif
+                                           );
+        }
+        else
+                return -ENOSYS;
+}
+
+static inline int ll_quota_off(struct super_block *sb, int off, int remount)
+{
+        if (sb->s_qcop->quota_off) {
+                return sb->s_qcop->quota_off(sb, off
+#ifdef HAVE_QUOTA_OFF_3ARGS
+                                             , remount
+#endif
+                                            );
+        }
+        else
+                return -ENOSYS;
+}
+
 static int fsfilt_ext3_quotactl(struct super_block *sb,
                                 struct obd_quotactl *oqc)
 {
diff --git a/lustre/lvfs/lvfs_linux.c b/lustre/lvfs/lvfs_linux.c
index 4269afe..b610b21 100644
--- a/lustre/lvfs/lvfs_linux.c
+++ b/lustre/lvfs/lvfs_linux.c
@@ -125,8 +125,8 @@ void push_ctxt(struct lvfs_run_ctxt *save, struct lvfs_run_ctxt *new_ctx,
         OBD_SET_CTXT_MAGIC(save);
 
         save->fs = get_fs();
-        LASSERT(cfs_atomic_read(&cfs_fs_pwd(current->fs)->d_count));
-        LASSERT(cfs_atomic_read(&new_ctx->pwd->d_count));
+        LASSERT(d_refcount(cfs_fs_pwd(current->fs)));
+        LASSERT(d_refcount(new_ctx->pwd));
         save->pwd = dget(cfs_fs_pwd(current->fs));
         save->pwdmnt = mntget(cfs_fs_mnt(current->fs));
         save->luc.luc_umask = cfs_curproc_umask();
@@ -375,7 +375,12 @@ int lustre_fsync(struct file *file)
         if (!file || !file->f_op || !file->f_op->fsync)
                 RETURN(-ENOSYS);
 
-        RETURN(file->f_op->fsync(file, file->f_dentry, 0));
+        RETURN(file->f_op->fsync(file,
+#ifndef HAVE_FSYNC_TWO_ARGS
+                                 file->f_dentry,
+#endif
+                                 0));
+
 }
 EXPORT_SYMBOL(lustre_fsync);
 
diff --git a/lustre/mdc/mdc_locks.c b/lustre/mdc/mdc_locks.c
index 7ec8408..da0ef44 100644
--- a/lustre/mdc/mdc_locks.c
+++ b/lustre/mdc/mdc_locks.c
@@ -635,7 +635,6 @@ int mdc_enqueue(struct obd_export *exp, struct ldlm_enqueue_info *einfo,
 {
         struct obd_device     *obddev = class_exp2obd(exp);
         struct ptlrpc_request *req = NULL;
-        struct req_capsule    *pill;
         int                    flags = extra_lock_flags;
         int                    rc;
         struct ldlm_res_id res_id;
@@ -686,7 +685,6 @@ int mdc_enqueue(struct obd_export *exp, struct ldlm_enqueue_info *einfo,
 
         if (IS_ERR(req))
                 RETURN(PTR_ERR(req));
-        pill = &req->rq_pill;
 
         /* It is important to obtain rpc_lock first (if applicable), so that
          * threads that are serialised with rpc_lock are not polluting our
diff --git a/lustre/mdc/mdc_reint.c b/lustre/mdc/mdc_reint.c
index 89cd5be..e5e40ae 100644
--- a/lustre/mdc/mdc_reint.c
+++ b/lustre/mdc/mdc_reint.c
@@ -41,7 +41,12 @@
 
 #ifdef __KERNEL__
 #ifndef AUTOCONF_INCLUDED
-# include <linux/config.h>
+#  include <linux/version.h>
+#  if LINUX_VERSION_CODE > KERNEL_VERSION(2, 6, 37)
+#    include <generated/autoconf.h>
+#  else
+#    include <linux/config.h>
+#  endif
 #endif
 # include <linux/module.h>
 # include <linux/kernel.h>
diff --git a/lustre/mds/mds_log.c b/lustre/mds/mds_log.c
index 70aac6e..86f9576 100644
--- a/lustre/mds/mds_log.c
+++ b/lustre/mds/mds_log.c
@@ -43,7 +43,12 @@
 #define DEBUG_SUBSYSTEM S_MDS
 
 #ifndef AUTOCONF_INCLUDED
-#include <linux/config.h>
+#  include <linux/version.h>
+#  if LINUX_VERSION_CODE > KERNEL_VERSION(2, 6, 37)
+#    include <generated/autoconf.h>
+#  else
+#    include <linux/config.h>
+#  endif
 #endif
 #include <linux/module.h>
 #include <linux/version.h>
diff --git a/lustre/mdt/mdt_identity.c b/lustre/mdt/mdt_identity.c
index f731044..b632bba 100644
--- a/lustre/mdt/mdt_identity.c
+++ b/lustre/mdt/mdt_identity.c
@@ -45,7 +45,12 @@
 #define DEBUG_SUBSYSTEM S_MDS
 
 #ifndef AUTOCONF_INCLUDED
-#include <linux/config.h>
+#  include <linux/version.h>
+#  if LINUX_VERSION_CODE > KERNEL_VERSION(2, 6, 37)
+#    include <generated/autoconf.h>
+#  else
+#    include <linux/config.h>
+#  endif
 #endif
 #include <linux/module.h>
 #include <linux/kernel.h>
diff --git a/lustre/mdt/mdt_idmap.c b/lustre/mdt/mdt_idmap.c
index 1d1005c..e7e0e4c 100644
--- a/lustre/mdt/mdt_idmap.c
+++ b/lustre/mdt/mdt_idmap.c
@@ -45,7 +45,12 @@
 #define DEBUG_SUBSYSTEM S_MDS
 
 #ifndef AUTOCONF_INCLUDED
-#include <linux/config.h>
+#  include <linux/version.h>
+#  if LINUX_VERSION_CODE > KERNEL_VERSION(2, 6, 37)
+#    include <generated/autoconf.h>
+#  else
+#    include <linux/config.h>
+#  endif
 #endif
 #include <linux/module.h>
 #include <linux/kernel.h>
diff --git a/lustre/obdclass/cl_lock.c b/lustre/obdclass/cl_lock.c
index 21919b3..12aed1f 100644
--- a/lustre/obdclass/cl_lock.c
+++ b/lustre/obdclass/cl_lock.c
@@ -295,14 +295,12 @@ static void cl_lock_free(const struct lu_env *env, struct cl_lock *lock)
 void cl_lock_put(const struct lu_env *env, struct cl_lock *lock)
 {
         struct cl_object        *obj;
-        struct cl_object_header *head;
         struct cl_site          *site;
 
         LINVRNT(cl_lock_invariant(env, lock));
         ENTRY;
         obj = lock->cll_descr.cld_obj;
         LINVRNT(obj != NULL);
-        head = cl_object_header(obj);
         site = cl_object_site(obj);
 
         CDEBUG(D_TRACE, "releasing reference: %d %p %lu\n",
diff --git a/lustre/obdclass/genops.c b/lustre/obdclass/genops.c
index e0a9416..fc2c0fe 100644
--- a/lustre/obdclass/genops.c
+++ b/lustre/obdclass/genops.c
@@ -1554,8 +1554,7 @@ static void obd_zombie_export_add(struct obd_export *exp) {
         cfs_list_add(&exp->exp_obd_chain, &obd_zombie_exports);
         cfs_spin_unlock(&obd_zombie_impexp_lock);
 
-        if (obd_zombie_impexp_notify != NULL)
-                obd_zombie_impexp_notify();
+        obd_zombie_impexp_notify();
 }
 
 /**
@@ -1569,8 +1568,7 @@ static void obd_zombie_import_add(struct obd_import *imp) {
         cfs_list_add(&imp->imp_zombie_chain, &obd_zombie_imports);
         cfs_spin_unlock(&obd_zombie_impexp_lock);
 
-        if (obd_zombie_impexp_notify != NULL)
-                obd_zombie_impexp_notify();
+        obd_zombie_impexp_notify();
 }
 
 /**
diff --git a/lustre/obdclass/linux/linux-module.c b/lustre/obdclass/linux/linux-module.c
index d893f16..6ff5e37 100644
--- a/lustre/obdclass/linux/linux-module.c
+++ b/lustre/obdclass/linux/linux-module.c
@@ -47,7 +47,12 @@
 
 #ifdef __KERNEL__
 #ifndef AUTOCONF_INCLUDED
-#include <linux/config.h> /* for CONFIG_PROC_FS */
+#  include <linux/version.h>
+#  if LINUX_VERSION_CODE > KERNEL_VERSION(2, 6, 37)
+#    include <generated/autoconf.h>
+#  else
+#    include <linux/config.h>
+#  endif
 #endif
 #include <linux/module.h>
 #include <linux/errno.h>
